/* FaceTable.c generated by valac 0.44.7, the Vala compiler
 * generated from FaceTable.vala, do not modify */

/* Copyright 2018 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>

#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_ROW (face_row_get_type ())
#define FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_ROW, FaceRow))
#define FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_ROW, FaceRowClass))
#define IS_FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_ROW))
#define IS_FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_ROW))
#define FACE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_ROW, FaceRowClass))

typedef struct _FaceRow FaceRow;
typedef struct _FaceRowClass FaceRowClass;
typedef struct _FaceRowPrivate FaceRowPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecFaceRow ParamSpecFaceRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;
typedef struct _FaceTablePrivate FaceTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _face_row_unref0(var) ((var == NULL) ? NULL : (var = (face_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FaceID {
	gint64 id;
};

struct _FaceRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FaceRowPrivate * priv;
	FaceID face_id;
	gchar* name;
	time_t time_created;
};

struct _FaceRowClass {
	GTypeClass parent_class;
	void (*finalize) (FaceRow *self);
};

struct _ParamSpecFaceRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _FaceTable {
	DatabaseTable parent_instance;
	FaceTablePrivate * priv;
};

struct _FaceTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer face_row_parent_class = NULL;
static gpointer face_table_parent_class = NULL;
static FaceTable* face_table_instance;
static FaceTable* face_table_instance = NULL;
extern sqlite3* database_table_db;

GType face_id_get_type (void) G_GNUC_CONST;
FaceID* face_id_dup (const FaceID* self);
void face_id_free (FaceID* self);
#define FACE_ID_INVALID ((gint64) -1)
void face_id_init (FaceID *self,
                   gint64 id);
gboolean face_id_is_invalid (FaceID *self);
gboolean face_id_is_valid (FaceID *self);
gpointer face_row_ref (gpointer instance);
void face_row_unref (gpointer instance);
GParamSpec* param_spec_face_row (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
void value_set_face_row (GValue* value,
                         gpointer v_object);
void value_take_face_row (GValue* value,
                          gpointer v_object);
gpointer value_get_face_row (const GValue* value);
GType face_row_get_type (void) G_GNUC_CONST;
FaceRow* face_row_new (void);
FaceRow* face_row_construct (GType object_type);
static void face_row_finalize (FaceRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType face_table_get_type (void) G_GNUC_CONST;
static FaceTable* face_table_new (void);
static FaceTable* face_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
void database_table_fatal (const gchar* op,
                           gint res);
FaceTable* face_table_get_instance (void);
GQuark database_error_quark (void);
FaceRow* face_table_add (FaceTable* self,
                         const gchar* name,
                         GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
void face_table_create_from_row (FaceTable* self,
                                 FaceRow* row,
                                 FaceID* result,
                                 GError** error);
void face_table_remove (FaceTable* self,
                        FaceID* face_id,
                        GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
gchar* face_table_get_name (FaceTable* self,
                            FaceID* face_id,
                            GError** error);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
FaceRow* face_table_get_row (FaceTable* self,
                             FaceID* face_id,
                             GError** error);
GeeList* face_table_get_all_rows (FaceTable* self,
                                  GError** error);
void face_table_rename (FaceTable* self,
                        FaceID* face_id,
                        const gchar* new_name,
                        GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
static void face_table_finalize (DatabaseTable * obj);

void
face_id_init (FaceID *self,
              gint64 id)
{
#line 13 "../src/db/FaceTable.vala"
	memset (self, 0, sizeof (FaceID));
#line 14 "../src/db/FaceTable.vala"
	(*self).id = id;
#line 220 "FaceTable.c"
}

gboolean
face_id_is_invalid (FaceID *self)
{
	gboolean result = FALSE;
#line 18 "../src/db/FaceTable.vala"
	result = (*self).id == FACE_ID_INVALID;
#line 18 "../src/db/FaceTable.vala"
	return result;
#line 231 "FaceTable.c"
}

gboolean
face_id_is_valid (FaceID *self)
{
	gboolean result = FALSE;
#line 22 "../src/db/FaceTable.vala"
	result = (*self).id != FACE_ID_INVALID;
#line 22 "../src/db/FaceTable.vala"
	return result;
#line 242 "FaceTable.c"
}

FaceID*
face_id_dup (const FaceID* self)
{
	FaceID* dup;
#line 8 "../src/db/FaceTable.vala"
	dup = g_new0 (FaceID, 1);
#line 8 "../src/db/FaceTable.vala"
	memcpy (dup, self, sizeof (FaceID));
#line 8 "../src/db/FaceTable.vala"
	return dup;
#line 255 "FaceTable.c"
}

void
face_id_free (FaceID* self)
{
#line 8 "../src/db/FaceTable.vala"
	g_free (self);
#line 263 "FaceTable.c"
}

GType
face_id_get_type (void)
{
	static volatile gsize face_id_type_id__volatile = 0;
	if (g_once_init_enter (&face_id_type_id__volatile)) {
		GType face_id_type_id;
		face_id_type_id = g_boxed_type_register_static ("FaceID", (GBoxedCopyFunc) face_id_dup, (GBoxedFreeFunc) face_id_free);
		g_once_init_leave (&face_id_type_id__volatile, face_id_type_id);
	}
	return face_id_type_id__volatile;
}

FaceRow*
face_row_construct (GType object_type)
{
	FaceRow* self = NULL;
#line 26 "../src/db/FaceTable.vala"
	self = (FaceRow*) g_type_create_instance (object_type);
#line 26 "../src/db/FaceTable.vala"
	return self;
#line 286 "FaceTable.c"
}

FaceRow*
face_row_new (void)
{
#line 26 "../src/db/FaceTable.vala"
	return face_row_construct (TYPE_FACE_ROW);
#line 294 "FaceTable.c"
}

static void
value_face_row_init (GValue* value)
{
#line 26 "../src/db/FaceTable.vala"
	value->data[0].v_pointer = NULL;
#line 302 "FaceTable.c"
}

static void
value_face_row_free_value (GValue* value)
{
#line 26 "../src/db/FaceTable.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/db/FaceTable.vala"
		face_row_unref (value->data[0].v_pointer);
#line 312 "FaceTable.c"
	}
}

static void
value_face_row_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 26 "../src/db/FaceTable.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = face_row_ref (src_value->data[0].v_pointer);
#line 324 "FaceTable.c"
	} else {
#line 26 "../src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 328 "FaceTable.c"
	}
}

static gpointer
value_face_row_peek_pointer (const GValue* value)
{
#line 26 "../src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 337 "FaceTable.c"
}

static gchar*
value_face_row_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 26 "../src/db/FaceTable.vala"
	if (collect_values[0].v_pointer) {
#line 348 "FaceTable.c"
		FaceRow * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/db/FaceTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/db/FaceTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 355 "FaceTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/db/FaceTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 359 "FaceTable.c"
		}
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = face_row_ref (object);
#line 363 "FaceTable.c"
	} else {
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 367 "FaceTable.c"
	}
#line 26 "../src/db/FaceTable.vala"
	return NULL;
#line 371 "FaceTable.c"
}

static gchar*
value_face_row_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	FaceRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/db/FaceTable.vala"
	if (!object_p) {
#line 26 "../src/db/FaceTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 386 "FaceTable.c"
	}
#line 26 "../src/db/FaceTable.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/db/FaceTable.vala"
		*object_p = NULL;
#line 392 "FaceTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/db/FaceTable.vala"
		*object_p = value->data[0].v_pointer;
#line 396 "FaceTable.c"
	} else {
#line 26 "../src/db/FaceTable.vala"
		*object_p = face_row_ref (value->data[0].v_pointer);
#line 400 "FaceTable.c"
	}
#line 26 "../src/db/FaceTable.vala"
	return NULL;
#line 404 "FaceTable.c"
}

GParamSpec*
param_spec_face_row (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	ParamSpecFaceRow* spec;
#line 26 "../src/db/FaceTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FACE_ROW), NULL);
#line 26 "../src/db/FaceTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/db/FaceTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/db/FaceTable.vala"
	return G_PARAM_SPEC (spec);
#line 423 "FaceTable.c"
}

gpointer
value_get_face_row (const GValue* value)
{
#line 26 "../src/db/FaceTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW), NULL);
#line 26 "../src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 433 "FaceTable.c"
}

void
value_set_face_row (GValue* value,
                    gpointer v_object)
{
	FaceRow * old;
#line 26 "../src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 26 "../src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/db/FaceTable.vala"
	if (v_object) {
#line 26 "../src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 26 "../src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/db/FaceTable.vala"
		face_row_ref (value->data[0].v_pointer);
#line 455 "FaceTable.c"
	} else {
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 459 "FaceTable.c"
	}
#line 26 "../src/db/FaceTable.vala"
	if (old) {
#line 26 "../src/db/FaceTable.vala"
		face_row_unref (old);
#line 465 "FaceTable.c"
	}
}

void
value_take_face_row (GValue* value,
                     gpointer v_object)
{
	FaceRow * old;
#line 26 "../src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 26 "../src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/db/FaceTable.vala"
	if (v_object) {
#line 26 "../src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 26 "../src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 486 "FaceTable.c"
	} else {
#line 26 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 490 "FaceTable.c"
	}
#line 26 "../src/db/FaceTable.vala"
	if (old) {
#line 26 "../src/db/FaceTable.vala"
		face_row_unref (old);
#line 496 "FaceTable.c"
	}
}

static void
face_row_class_init (FaceRowClass * klass,
                     gpointer klass_data)
{
#line 26 "../src/db/FaceTable.vala"
	face_row_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/db/FaceTable.vala"
	((FaceRowClass *) klass)->finalize = face_row_finalize;
#line 508 "FaceTable.c"
}

static void
face_row_instance_init (FaceRow * self,
                        gpointer klass)
{
#line 26 "../src/db/FaceTable.vala"
	self->ref_count = 1;
#line 517 "FaceTable.c"
}

static void
face_row_finalize (FaceRow * obj)
{
	FaceRow * self;
#line 26 "../src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_ROW, FaceRow);
#line 26 "../src/db/FaceTable.vala"
	g_signal_handlers_destroy (self);
#line 28 "../src/db/FaceTable.vala"
	_g_free0 (self->name);
#line 530 "FaceTable.c"
}

GType
face_row_get_type (void)
{
	static volatile gsize face_row_type_id__volatile = 0;
	if (g_once_init_enter (&face_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_face_row_init, value_face_row_free_value, value_face_row_copy_value, value_face_row_peek_pointer, "p", value_face_row_collect_value, "p", value_face_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (FaceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceRow), 0, (GInstanceInitFunc) face_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType face_row_type_id;
		face_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FaceRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&face_row_type_id__volatile, face_row_type_id);
	}
	return face_row_type_id__volatile;
}

gpointer
face_row_ref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 26 "../src/db/FaceTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/db/FaceTable.vala"
	return instance;
#line 557 "FaceTable.c"
}

void
face_row_unref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 26 "../src/db/FaceTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/db/FaceTable.vala"
		FACE_ROW_GET_CLASS (self)->finalize (self);
#line 26 "../src/db/FaceTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 571 "FaceTable.c"
	}
}

static FaceTable*
face_table_construct (GType object_type)
{
	FaceTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 35 "../src/db/FaceTable.vala"
	self = (FaceTable*) database_table_construct (object_type);
#line 36 "../src/db/FaceTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "FaceTable");
#line 39 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 39 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "FaceTable " "(" "id INTEGER NOT NULL PRIMARY KEY, " "name TEXT NOT NULL, " "time_created TIMESTAMP" ")", -1, &_tmp1_, NULL);
#line 39 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 39 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 39 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 46 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 48 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 48 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp3_);
#line 49 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 50 "../src/db/FaceTable.vala"
		database_table_fatal ("create FaceTable", res);
#line 609 "FaceTable.c"
	}
#line 35 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 35 "../src/db/FaceTable.vala"
	return self;
#line 615 "FaceTable.c"
}

static FaceTable*
face_table_new (void)
{
#line 35 "../src/db/FaceTable.vala"
	return face_table_construct (TYPE_FACE_TABLE);
#line 623 "FaceTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 57 "../src/db/FaceTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 631 "FaceTable.c"
}

FaceTable*
face_table_get_instance (void)
{
	FaceTable* result = NULL;
	FaceTable* _tmp0_;
	FaceTable* _tmp2_;
	FaceTable* _tmp3_;
#line 54 "../src/db/FaceTable.vala"
	_tmp0_ = face_table_instance;
#line 54 "../src/db/FaceTable.vala"
	if (_tmp0_ == NULL) {
#line 645 "FaceTable.c"
		FaceTable* _tmp1_;
#line 55 "../src/db/FaceTable.vala"
		_tmp1_ = face_table_new ();
#line 55 "../src/db/FaceTable.vala"
		_database_table_unref0 (face_table_instance);
#line 55 "../src/db/FaceTable.vala"
		face_table_instance = _tmp1_;
#line 653 "FaceTable.c"
	}
#line 57 "../src/db/FaceTable.vala"
	_tmp2_ = face_table_instance;
#line 57 "../src/db/FaceTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 57 "../src/db/FaceTable.vala"
	result = _tmp3_;
#line 57 "../src/db/FaceTable.vala"
	return result;
#line 663 "FaceTable.c"
}

FaceRow*
face_table_add (FaceTable* self,
                const gchar* name,
                GError** error)
{
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	time_t time_created = 0;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	FaceRow* row = NULL;
	FaceRow* _tmp8_;
	FaceRow* _tmp9_;
	sqlite3* _tmp10_;
	FaceRow* _tmp11_;
	gchar* _tmp12_;
	FaceRow* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 60 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 60 "../src/db/FaceTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 62 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 62 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 62 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 62 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 62 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 64 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 66 "../src/db/FaceTable.vala"
	time_created = (time_t) now_sec ();
#line 68 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 68 "../src/db/FaceTable.vala"
	_tmp4_ = g_strdup (name);
#line 68 "../src/db/FaceTable.vala"
	_tmp5_ = g_free;
#line 68 "../src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 69 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 70 "../src/db/FaceTable.vala"
	_tmp6_ = stmt;
#line 70 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, (gint64) time_created);
#line 71 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 73 "../src/db/FaceTable.vala"
	_tmp7_ = stmt;
#line 73 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp7_);
#line 74 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 75 "../src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.add", res, &_inner_error0_);
#line 75 "../src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 75 "../src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 75 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 75 "../src/db/FaceTable.vala"
				return NULL;
#line 743 "FaceTable.c"
			} else {
#line 75 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 75 "../src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 75 "../src/db/FaceTable.vala"
				return NULL;
#line 753 "FaceTable.c"
			}
		}
	}
#line 77 "../src/db/FaceTable.vala"
	_tmp8_ = face_row_new ();
#line 77 "../src/db/FaceTable.vala"
	row = _tmp8_;
#line 78 "../src/db/FaceTable.vala"
	_tmp9_ = row;
#line 78 "../src/db/FaceTable.vala"
	_tmp10_ = database_table_db;
#line 78 "../src/db/FaceTable.vala"
	face_id_init (&_tmp9_->face_id, sqlite3_last_insert_rowid (_tmp10_));
#line 79 "../src/db/FaceTable.vala"
	_tmp11_ = row;
#line 79 "../src/db/FaceTable.vala"
	_tmp12_ = g_strdup (name);
#line 79 "../src/db/FaceTable.vala"
	_g_free0 (_tmp11_->name);
#line 79 "../src/db/FaceTable.vala"
	_tmp11_->name = _tmp12_;
#line 80 "../src/db/FaceTable.vala"
	_tmp13_ = row;
#line 80 "../src/db/FaceTable.vala"
	_tmp13_->time_created = time_created;
#line 82 "../src/db/FaceTable.vala"
	result = row;
#line 82 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 82 "../src/db/FaceTable.vala"
	return result;
#line 785 "FaceTable.c"
}

void
face_table_create_from_row (FaceTable* self,
                            FaceRow* row,
                            FaceID* result,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3* _tmp9_;
	FaceID _tmp10_ = {0};
	GError* _inner_error0_ = NULL;
#line 85 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 85 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_ROW (row));
#line 87 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 87 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 87 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 87 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 87 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 89 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 91 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 91 "../src/db/FaceTable.vala"
	_tmp4_ = row->name;
#line 91 "../src/db/FaceTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 91 "../src/db/FaceTable.vala"
	_tmp6_ = g_free;
#line 91 "../src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 92 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 93 "../src/db/FaceTable.vala"
	_tmp7_ = stmt;
#line 93 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 2, (gint64) row->time_created);
#line 94 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 96 "../src/db/FaceTable.vala"
	_tmp8_ = stmt;
#line 96 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp8_);
#line 97 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 98 "../src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.create_from_row", res, &_inner_error0_);
#line 98 "../src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 98 "../src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 98 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 98 "../src/db/FaceTable.vala"
				return;
#line 860 "FaceTable.c"
			} else {
#line 98 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 98 "../src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 98 "../src/db/FaceTable.vala"
				return;
#line 870 "FaceTable.c"
			}
		}
	}
#line 100 "../src/db/FaceTable.vala"
	_tmp9_ = database_table_db;
#line 100 "../src/db/FaceTable.vala"
	face_id_init (&_tmp10_, sqlite3_last_insert_rowid (_tmp9_));
#line 100 "../src/db/FaceTable.vala"
	*result = _tmp10_;
#line 100 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 100 "../src/db/FaceTable.vala"
	return;
#line 884 "FaceTable.c"
}

void
face_table_remove (FaceTable* self,
                   FaceID* face_id,
                   GError** error)
{
	FaceID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 103 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 103 "../src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 104 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 104 "../src/db/FaceTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 104 "../src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 104 "../src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 104 "../src/db/FaceTable.vala"
			return;
#line 910 "FaceTable.c"
		} else {
#line 104 "../src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 104 "../src/db/FaceTable.vala"
			return;
#line 918 "FaceTable.c"
		}
	}
}

gchar*
face_table_get_name (FaceTable* self,
                     FaceID* face_id,
                     GError** error)
{
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	FaceID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 107 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 107 "../src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 109 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 109 "../src/db/FaceTable.vala"
	_tmp2_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", &_tmp1_);
#line 109 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 109 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 109 "../src/db/FaceTable.vala"
	if (!_tmp2_) {
#line 110 "../src/db/FaceTable.vala"
		result = NULL;
#line 110 "../src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 110 "../src/db/FaceTable.vala"
		return result;
#line 956 "FaceTable.c"
	}
#line 112 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 112 "../src/db/FaceTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 112 "../src/db/FaceTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 112 "../src/db/FaceTable.vala"
	result = _tmp5_;
#line 112 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 112 "../src/db/FaceTable.vala"
	return result;
#line 970 "FaceTable.c"
}

FaceRow*
face_table_get_row (FaceTable* self,
                    FaceID* face_id,
                    GError** error)
{
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	FaceID _tmp4_;
	sqlite3_stmt* _tmp5_;
	FaceRow* row = NULL;
	FaceRow* _tmp6_;
	FaceRow* _tmp7_;
	FaceID _tmp8_;
	FaceRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	FaceRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 115 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 115 "../src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 117 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 117 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, time_created FROM FaceTable WHERE id=?", -1, &_tmp1_, NULL);
#line 117 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 117 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 117 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 119 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 121 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 121 "../src/db/FaceTable.vala"
	_tmp4_ = *face_id;
#line 121 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 122 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 124 "../src/db/FaceTable.vala"
	_tmp5_ = stmt;
#line 124 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp5_);
#line 125 "../src/db/FaceTable.vala"
	if (res == SQLITE_DONE) {
#line 126 "../src/db/FaceTable.vala"
		result = NULL;
#line 126 "../src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 126 "../src/db/FaceTable.vala"
		return result;
#line 1034 "FaceTable.c"
	} else {
#line 127 "../src/db/FaceTable.vala"
		if (res != SQLITE_ROW) {
#line 128 "../src/db/FaceTable.vala"
			database_table_throw_error ("FaceTable.get_row", res, &_inner_error0_);
#line 128 "../src/db/FaceTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/db/FaceTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 128 "../src/db/FaceTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 128 "../src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 128 "../src/db/FaceTable.vala"
					return NULL;
#line 1050 "FaceTable.c"
				} else {
#line 128 "../src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 128 "../src/db/FaceTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/db/FaceTable.vala"
					g_clear_error (&_inner_error0_);
#line 128 "../src/db/FaceTable.vala"
					return NULL;
#line 1060 "FaceTable.c"
				}
			}
		}
	}
#line 130 "../src/db/FaceTable.vala"
	_tmp6_ = face_row_new ();
#line 130 "../src/db/FaceTable.vala"
	row = _tmp6_;
#line 131 "../src/db/FaceTable.vala"
	_tmp7_ = row;
#line 131 "../src/db/FaceTable.vala"
	_tmp8_ = *face_id;
#line 131 "../src/db/FaceTable.vala"
	_tmp7_->face_id = _tmp8_;
#line 132 "../src/db/FaceTable.vala"
	_tmp9_ = row;
#line 132 "../src/db/FaceTable.vala"
	_tmp10_ = stmt;
#line 132 "../src/db/FaceTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 132 "../src/db/FaceTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 132 "../src/db/FaceTable.vala"
	_g_free0 (_tmp9_->name);
#line 132 "../src/db/FaceTable.vala"
	_tmp9_->name = _tmp12_;
#line 133 "../src/db/FaceTable.vala"
	_tmp13_ = row;
#line 133 "../src/db/FaceTable.vala"
	_tmp14_ = stmt;
#line 133 "../src/db/FaceTable.vala"
	_tmp13_->time_created = (time_t) sqlite3_column_int64 (_tmp14_, 1);
#line 135 "../src/db/FaceTable.vala"
	result = row;
#line 135 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 135 "../src/db/FaceTable.vala"
	return result;
#line 1099 "FaceTable.c"
}

GeeList*
face_table_get_all_rows (FaceTable* self,
                         GError** error)
{
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 138 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 140 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 140 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created FROM FaceTable", -1, &_tmp1_, NULL);
#line 140 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 140 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 140 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 142 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 144 "../src/db/FaceTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, (GDestroyNotify) face_row_unref, NULL, NULL, NULL);
#line 144 "../src/db/FaceTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 1133 "FaceTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 146 "../src/db/FaceTable.vala"
		_tmp4_ = TRUE;
#line 146 "../src/db/FaceTable.vala"
		while (TRUE) {
#line 1140 "FaceTable.c"
			sqlite3_stmt* _tmp5_;
			FaceRow* row = NULL;
			FaceRow* _tmp6_;
			FaceRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			FaceRow* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			GeeList* _tmp15_;
			FaceRow* _tmp16_;
#line 146 "../src/db/FaceTable.vala"
			if (!_tmp4_) {
#line 1156 "FaceTable.c"
			}
#line 146 "../src/db/FaceTable.vala"
			_tmp4_ = FALSE;
#line 147 "../src/db/FaceTable.vala"
			_tmp5_ = stmt;
#line 147 "../src/db/FaceTable.vala"
			res = sqlite3_step (_tmp5_);
#line 148 "../src/db/FaceTable.vala"
			if (res == SQLITE_DONE) {
#line 149 "../src/db/FaceTable.vala"
				break;
#line 1168 "FaceTable.c"
			} else {
#line 150 "../src/db/FaceTable.vala"
				if (res != SQLITE_ROW) {
#line 151 "../src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", res, &_inner_error0_);
#line 151 "../src/db/FaceTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/db/FaceTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 151 "../src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 151 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 151 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 151 "../src/db/FaceTable.vala"
							return NULL;
#line 1186 "FaceTable.c"
						} else {
#line 151 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 151 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 151 "../src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/db/FaceTable.vala"
							g_clear_error (&_inner_error0_);
#line 151 "../src/db/FaceTable.vala"
							return NULL;
#line 1198 "FaceTable.c"
						}
					}
				}
			}
#line 154 "../src/db/FaceTable.vala"
			_tmp6_ = face_row_new ();
#line 154 "../src/db/FaceTable.vala"
			row = _tmp6_;
#line 155 "../src/db/FaceTable.vala"
			_tmp7_ = row;
#line 155 "../src/db/FaceTable.vala"
			_tmp8_ = stmt;
#line 155 "../src/db/FaceTable.vala"
			face_id_init (&_tmp7_->face_id, sqlite3_column_int64 (_tmp8_, 0));
#line 156 "../src/db/FaceTable.vala"
			_tmp9_ = row;
#line 156 "../src/db/FaceTable.vala"
			_tmp10_ = stmt;
#line 156 "../src/db/FaceTable.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 156 "../src/db/FaceTable.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 156 "../src/db/FaceTable.vala"
			_g_free0 (_tmp9_->name);
#line 156 "../src/db/FaceTable.vala"
			_tmp9_->name = _tmp12_;
#line 157 "../src/db/FaceTable.vala"
			_tmp13_ = row;
#line 157 "../src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 157 "../src/db/FaceTable.vala"
			_tmp13_->time_created = (time_t) sqlite3_column_int64 (_tmp14_, 2);
#line 159 "../src/db/FaceTable.vala"
			_tmp15_ = rows;
#line 159 "../src/db/FaceTable.vala"
			_tmp16_ = row;
#line 159 "../src/db/FaceTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), _tmp16_);
#line 146 "../src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1239 "FaceTable.c"
		}
	}
#line 162 "../src/db/FaceTable.vala"
	result = rows;
#line 162 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 162 "../src/db/FaceTable.vala"
	return result;
#line 1248 "FaceTable.c"
}

void
face_table_rename (FaceTable* self,
                   FaceID* face_id,
                   const gchar* new_name,
                   GError** error)
{
	FaceID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 165 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 165 "../src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 165 "../src/db/FaceTable.vala"
	g_return_if_fail (new_name != NULL);
#line 166 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 166 "../src/db/FaceTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", new_name, &_inner_error0_);
#line 166 "../src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "../src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 166 "../src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 166 "../src/db/FaceTable.vala"
			return;
#line 1277 "FaceTable.c"
		} else {
#line 166 "../src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 166 "../src/db/FaceTable.vala"
			return;
#line 1285 "FaceTable.c"
		}
	}
}

static void
face_table_class_init (FaceTableClass * klass,
                       gpointer klass_data)
{
#line 32 "../src/db/FaceTable.vala"
	face_table_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/db/FaceTable.vala"
	((DatabaseTableClass *) klass)->finalize = face_table_finalize;
#line 1298 "FaceTable.c"
}

static void
face_table_instance_init (FaceTable * self,
                          gpointer klass)
{
}

static void
face_table_finalize (DatabaseTable * obj)
{
	FaceTable * self;
#line 32 "../src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_TABLE, FaceTable);
#line 32 "../src/db/FaceTable.vala"
	DATABASE_TABLE_CLASS (face_table_parent_class)->finalize (obj);
#line 1315 "FaceTable.c"
}

GType
face_table_get_type (void)
{
	static volatile gsize face_table_type_id__volatile = 0;
	if (g_once_init_enter (&face_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FaceTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceTable), 0, (GInstanceInitFunc) face_table_instance_init, NULL };
		GType face_table_type_id;
		face_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "FaceTable", &g_define_type_info, 0);
		g_once_init_leave (&face_table_type_id__volatile, face_table_type_id);
	}
	return face_table_type_id__volatile;
}

